function [phase,Fs,N] = BFphase(Fs,N,theta) % far-field assumption


    x = [8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,-[-8:8],-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,[-8:7]]; % x y coordinate of elements by the order of top right and clockwise
    y = [-[-8:8],-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,[-8:8],8,8,8,8,8,8,8,8,8,8,8,8,8,8,8];
    dist= ((x-8).^2+(y-8).^2).^(1/2);% distance of every element to the reference one on the  top right in cm
    beta=asind((8-y(:,2:64))./dist(:,2:64));
    p=dist(:,2:64);
    q=cosd(theta-beta);
    T=[0,p.*q]/34000; %time to arrive to each element in second 
    t=(1/Fs)*[0:15]/16;% delay caused by multiplexing 
    t1=transpose([t,t,t,t]);
    phase=[ T(1);T(2);T(3);T(4);T(5);T(6);T(7);T(8);T(9);T(10);T(11);T(12);T(13);T(14);T(15);T(16);
            T(17);T(18);T(19);T(20);T(21);T(22);T(23);T(24);T(25);T(26);T(27);T(28);T(29);T(30);T(31);T(32);
            T(33);T(34);T(35);T(36);T(37);T(38);T(39);T(40);T(41);T(42);T(43);T(44);T(45);T(46);T(47);T(48);
            T(49);T(50);T(51);T(52);T(53);T(54);T(55);T(56);T(57);T(58);T(59);T(60);T(61);T(62);T(63);T(64)]+t1;






end