clc;clear all;
load('configuration.mat');
fileId = fopen( conf.SOURCE_FILE );
window = eval( [conf.WINDOW,'(', num2str(conf.N),')''*',num2str(conf.WINDOW_COEF),';'] );
pre_data    = [];
post_data   = [];
for i = 1 : 4
    mics = getDataBySecond(fileId, i);
    if( isempty(mics) )
        continue;
    end
    pre_data = [pre_data; mics(1,:)];
    hpdata = mics;
    
    for j=1:64
        hpdata(j,:) = highp(mics(j,:),300,250,0.1,20,5000); 
    end
%     lagTable = getLagTable(mics);
%     ADJ_DATA = getAdjusted( mics , lagTable, 'time', conf.Fs/conf.N );
%     post_data   = [post_data; sum(ADJ_DATA(7:12,:))];
    currentdata = hpdata(1,:);
    ADJ_DATA = hpdata;
    
    
    for j = 2 : 15
        maxpower = 0;
        maxID = -4;
        maxseq = hpdata(j,:);
        for k = -120 : 120
            freq_data = fft( hpdata(j,:), [], 2);
%             freq_axis = ((0:N-1)-floor(N/2))*FREQ_RESO;
            freq_axis = ((0:50000-1)-floor(50000/2))* conf.Fs/conf.N;
            freq_axis = ifftshift(freq_axis);
            freq_data = freq_data.*exp(2*pi*1i*freq_axis*k/50000);
            temp = real( ifft(freq_data) );
            
            result = xcorr(hpdata(1,:),temp,'unbiased');
            
            [row,col] = size(result);
            
            middle = (col+1) / 2; 
            
            temppower = result(middle);
            
            if( temppower > maxpower )
                maxpower = temppower;
                maxID = k;
                maxseq = temp;
            end 
        end
        ADJ_DATA(j,:) = maxseq;
        currentdata = currentdata + maxseq;
    end
    post_data   = [post_data; currentdata];
end

% audioPlay(pre_data, 'off', [0 2]);
audioPlay(post_data, 'off', [0 2]);