
MODE = 3;
pre_data = [];
post_data = [];
switch( MODE )
    
    case 1      % Simulation
        musicData = load('handel') ;
        [amount, ~] = size(musicData.y) ;
        channels = zeros(64,amount);
        
        for i = 1 : 64
            channels(i,:) = musicData.y + wgn( amount, 1, -25) ;
        end
        % figure, plot(channels(1,:));
        % figure, plot(sum(channels));
        oneDataObj = audioplayer( channels(1,:), musicData.Fs) ;
        sumDataObj = audioplayer( sum(channels)/16, musicData.Fs) ;
        playblocking(oneDataObj);
        playblocking(sumDataObj);
    
    case 2      % Pure tone
%         fileId = fopen( 'C:/temp/uPhoneArray_Elvis.bin' );
        fileId = fopen( 'C:/temp/uPhoneArray_Realtimetest.bin' );
%         for i = 1 : 3
        filter_window = 2000;
        data_rear = zeros(conf.MIC_NUM , filter_window);
        for i = 1 : 5
%         while(~feof(fileId))
            mics = getDataBySecond(fileId, 0);
            if( isempty(mics) )
                break;
            end
            pre_data = [pre_data; mics(1,:)-mean(mics(1,:))];
            
            
%             b = fir2(filter_window/4,[0, 0.006, 0.01, 1], [0 0 1 1]);
%             filter_arg = {b;1};
%             
%             
%             
%             longer_mics = getFiltered( filter_arg, [data_rear, mics] );
%             new_mics = longer_mics(:, filter_window+1 : end);
%             lagTable = getLagTable(new_mics);
%             ADJ_DATA =  getAdjusted(new_mics, lagTable, 'time', conf.Fs/conf.N);
%             data_rear = mics(:,conf.N-filter_window+1:end);
            lagTable = getLagTable(mics);
            ADJ_DATA =  getAdjusted(mics, lagTable, 'time', conf.Fs/conf.N);
            
            post_data = [post_data; sum(ADJ_DATA)-mean(sum(ADJ_DATA))];
            
            

%             pre_data = [pre_data; mics(1,:)-mean(mics(1,:))];
%             lagTable = getLagTable(mics);
%             ADJ_DATA =  getAdjusted(mics, lagTable, 'time', 1);
%             post_data = [post_data; sum(ADJ_DATA)-mean(sum(ADJ_DATA))];           
        end
        audioPlay(pre_data, 'off');
        audioPlay(post_data/16,'off', 'Rec_new4000_post.wav');
        
    case 3      % Music
        fileId = fopen( 'C:/temp/uPhoneArray_MysoulLong.bin' );
%         fileId = fopen( 'C:/temp/uPhoneArray_Realtimetest.bin' );
%         [b, a] = butter(1,0.005,'high');
%         filter_arg = {b;a};
%         b = fir1(1000,0.006,'high');
%         filter_arg = {b;1};

        filter_window = 500;
        b = fir2(filter_window,[0, 0.006, 0.01, 1], [0 0 1 1]);
%         figure,freqz(b,1);
        filter_arg = {b;1};
        
        data_rear = zeros(conf.MIC_NUM , filter_window);
        
%         for i = 1 : 5
        i = 1;
        while(~feof(fileId))
            mics = getDataBySecond(fileId, 0);
            if( isempty(mics) )
                break;
            end
            
            longer_mics = getFiltered( filter_arg, [data_rear, mics(1:16,:)] );
            new_mics = longer_mics(:, filter_window+1 : end);
            lagTable = getLagTable(new_mics);
            ADJ_DATA =  getAdjusted(new_mics, lagTable, 'time', conf.Fs/conf.N);
            
            if i ~= 1
                pre_data = [pre_data; new_mics(1,:)];
                post_data = [post_data; sum(ADJ_DATA)/conf.MIC_NUM];
            end
            i = i + 1;
            data_rear = mics(1:16,conf.N-filter_window+1:end);
            
%             mics1 = getFiltered( filter_arg, mics );
% %             figure, plot( mics1(1,:) );
%             pre_data = [pre_data; mics(1,:)];
%             lagTable = getLagTable(mics);
%             ADJ_DATA =  getAdjusted(mics, lagTable, 'time', 1);
%             [mic_num, ~] = size(ADJ_DATA);
%             post_data = [post_data; sum(ADJ_DATA)/mic_num];      
        end
        audioPlay(pre_data, 'on','PREDATA_new_MysoulLong.wav');
%         audioPlay(pre_data(:,50:end), 'off');
        audioPlay(post_data, 'on','POSTDATA_new_MysoulLong.wav');
end
        




%%