function [power, s]=Beamforming(filted_data, bandPass, phi)


[phase,Fs,N,] = BFphase(50000,50000,phi);
delay = (phase-phase(1))*Fs;
coef = (2*pi*delay*(bandPass(1):bandPass(2)))/N;
% mag=abs(filted_data);
% ang=angle(filted_data);
% diff = ang + coef;
% shiftedwave = mag .* exp(1i * diff);
shiftedwave = filted_data.*exp(1i * coef);
s = sum(shiftedwave);
power = sum( abs(s).^2 );


end
