function [ number ] = getCurWorkerNum( filename )
%GETTXTLINES    To get the number of workers who have already joined the
%group
%INPUT:
%   filename  The name of the file that records workers' IPs
%OUTPUT:
%   number    The number of workers who have already joined the
%group

fid = fopen(filename,'r');
if( fid==-1 )
    number = 0;
else
    records = fgetl(fid);
    [ ~, number ] = size( strfind(records,'|') );
    fclose(fid);
end



end
