fileId = fopen( 'C:/temp/uPhoneArray_forLagTable.bin' );
lagTableAll = [];
i = 1;
filter_window = 500;
data_rear = zeros(conf.MIC_NUM , filter_window);
b = fir2(filter_window,[0, 0.006, 0.01, 1], [0 0 1 1]);
filter_arg = {b;1};
while (~feof(fileId))
    mics = getDataBySecond(fileId, 0);
    if( isempty(mics) )
        break;
    end
    longer_mics = getFiltered( filter_arg, mics(1:16,:) );
    new_mics = longer_mics(:, filter_window+1 : end);
    lagTableAll = [ lagTableAll; getLagTable(new_mics)' ];
    i = i + 1;
end
fclose(fileId);

lagTable = mean(lagTableAll);
save('lagTable.mat', 'lagTable');
configuration;